MODULE ChgCR;

IMPORT FIO, FIOStd, Lib3, Config, Paths, StrOut;
IMPORT IO;

CONST
  tmp = 'ChgCR.$$$';
  cLF = CHR( 0AH );
  cCR = CHR( 0DH );


PROCEDURE Process( fn-: ARRAY OF CHAR );
VAR
  in, out: FIO.File;

  PROCEDURE Err();
  CONST
    f ::= FIOStd.err;
  VAR
    b: StrOut.TBuffer;
    s: ARRAY [0..127] OF CHAR;
  BEGIN
    StrOut.Init( b, s );
    StrOut.WrStr( b, "File '" );
    StrOut.WrStr( b, fn );
    StrOut.WrStr( b, "' does not exist." );
    StrOut.WrLn( b );
    FIO.WrStr( f, s );
  END Err;

  PROCEDURE Open();
  BEGIN
    IF ~ FIO.Exists( fn ) THEN Err() END;
    in := FIO.OpenRead( fn );
    out := FIO.Create( tmp );
  END Open;

  PROCEDURE Write( c: CHAR );
  BEGIN
    FIO.WrBin( out, c, 1 );
  END Write;

  PROCEDURE Filter();
  VAR
    c: CHAR;
    n: CARDINAL;
  BEGIN
    n := FIO.RdBin( in, c, 1 );
    WHILE n > 0 DO
      IF c = cCR THEN
        (* strip *)
      ELSIF c = cLF THEN
        IF ~ Config.data.unx THEN Write( cCR ) END;
        Write( cLF );
      ELSE
        Write( c );
      END;
      n := FIO.RdBin( in, c, 1 );
    END;
  END Filter;

  PROCEDURE CopyTime();
  VAR
    d: LONGCARD;
  BEGIN
    IF Config.data.tim THEN RETURN END;
    d := FIO.GetFileDate( in );
    FIO.SetFileDate( out, d );
  END CopyTime;

  PROCEDURE Close();
  BEGIN
    FIO.Close( out );
    FIO.Close( in );
  END Close;

  PROCEDURE Rename();
  BEGIN
    FIO.Erase( fn );
    FIO.Rename( tmp, fn );
  END Rename;

BEGIN
  Open();
  Filter();
  CopyTime();
  Close();
  Rename();
END Process;


PROCEDURE Main();
VAR
  ok: BOOLEAN;
  idx: CARDINAL;

  PROCEDURE Err();
  CONST
    f ::= FIOStd.err;
  VAR
    b: StrOut.TBuffer;
    s: ARRAY [0..127] OF CHAR;
  BEGIN
    StrOut.Init( b, s );
    StrOut.WrStr( b, "File '" );
    StrOut.WrStr( b, Config.data.fls[ idx ] );
    StrOut.WrStr( b, "' does not exist." );
    StrOut.WrLn( b );
    FIO.WrStr( f, s );
  END Err;

BEGIN
  FOR idx := 1 TO Config.data.cnt DO
    ok := Paths.Init( Config.data.fls[ idx ] );
    IF ~ ok THEN Err() END;
    WHILE ok DO
      Process( Paths.str );
      ok := Paths.Read();
    END;
  END;
END Main;

BEGIN
  Main();
  Lib3.SetReturnCode( 0 );
END ChgCR.
