(* path expansion *)
IMPLEMENTATION MODULE Paths;

FROM SYSTEM IMPORT ADR;
IMPORT Str, Lib, FIO, FIOStd;

(*# save, call( o_a_copy => off ) *)

VAR
  ent: FIO.DirEntry;


PROCEDURE ShowPath();
CONST
  f ::= FIOStd.err;
BEGIN
  FIO.WrStr( f, 'Paths.Show: "' );
  FIO.WrStr( f, pth.d );
  FIO.WrStr( f, '", "' );
  FIO.WrStr( f, pth.p );
  FIO.WrStr( f, '", "' );
  FIO.WrStr( f, pth.n );
  FIO.WrStr( f, '", "' );
  FIO.WrStr( f, pth.e );
  FIO.WrStr( f, '"' );
  FIO.WrLn( f );
END ShowPath;


PROCEDURE Reset();
BEGIN
  act := FALSE;
  str := '';
  Lib.Fill( ADR(pth), SIZE(pth), 0C );
END Reset;


PROCEDURE Process(): BOOLEAN;
VAR
  p: TPathDesc;
BEGIN
  IF ~ act THEN Reset(); RETURN FALSE END;
  Lib.SplitAllPath( ent.name, p.d, p.p, p.n, p.e );
  pth.n := p.n;
  pth.e := p.e;
  Lib.MakeAllPath( str, pth.d, pth.p, pth.n, pth.e );
  RETURN TRUE;
END Process;

PROCEDURE Init( s: ARRAY OF CHAR ): BOOLEAN;  (* not expanded *)
CONST
  attr = FIO.FileAttr{};
VAR
  ioc: BOOLEAN;
BEGIN
  Lib.SplitAllPath( s, pth.d, pth.p, pth.n, pth.e );
  (*
  ShowPath();
  IF IsDir( s ) THEN
    pth.n := '*'; pth.e := '.*';
    ShowPath();
  END;
  Lib.MakeAllPath( str, pth.d, pth.p, pth.n, pth.e );
  *)

  ioc := FIO.IOcheck;
  FIO.IOcheck := FALSE;
  act := FIO.ReadFirstEntry( s, attr, ent );
  FIO.IOcheck := ioc;

  RETURN Process();
END Init;

PROCEDURE Read(): BOOLEAN;
VAR
  ioc: BOOLEAN;
BEGIN
  IF ~ act THEN Lib.FatalError( 'Paths.Read: Not active' ); HALT END;

  ioc := FIO.IOcheck;
  FIO.IOcheck := FALSE;
  act := FIO.ReadNextEntry( ent );
  FIO.IOcheck := ioc;

  RETURN Process();
END Read;

BEGIN
  Reset();
END Paths.
